%% realimentacion de estado no controlable
clear all;
close all;
clc;
%matrices del sistema
A=[0.9 0.2 -0.2; -1.2 2.4 -1.4; -1.2 1.7 -0.7];
B=[-0.1; 2; 2];
C=[0 0 1];
D=0;
Ts=0.01
P1=ss(A,B,C,0,Ts);
clc;
disp(' Modelo de Estado');
disp(' ')
P1
%%
% disp(' calculo de la matriz transferencia (Simblico)')
% syms s;
% Id=eye(3);
% Fi=(s*Id-A);
% disp(' calculo de la matriz de transicion [sI-A](Simblico)')
% Fi
% disp(' Determinante (Simblico)')
% vpa(det(Fi),5)
% pause
% disp(' Inversa')
% Fi2=Fi^-1
% disp(' Transferencia')
% 
% G1=vpa(C*inv(Fi)*B,3)
% 
clc;
disp(' ')
disp(' ')
disp(' autovalores del modelo')
disp(' ')
pole(P1)
disp(' ')
u=ctrb(P1);
rg=rank(u);
dt=round(det(u));
disp('  ');
disp('  MATRIZ CONTROLABILIDAD');
disp(' ');
u
disp(sprintf('  DETERMINANTE = %d -> El sistema no es totalmente controlable ',dt));
disp('  ');
disp(sprintf('  RANGO DE LA MATRIZ = %d ',rg));
%% TRANSFORMACION LINEAL
clc;
Q=[[u(:,1:2)],[0;0;1]];
clc;
disp('  ');
disp('  MATRIZ DE TRANSFORMACION');
disp(' ');
Q
P2=ss2ss(P1,Q^-1);
%P2.a=round(P2.a);

disp('  ');
disp('  MODELO TRANSFORMADO');
disp(' ');
P2
%% SUBMODELO CONTROLABLE
A3=P2.a(1:2,1:2);
B3=P2.b(1:2,:);
C3=[0 1];
D3=0;
%P3=ss(A3,B3,C3,D3)
clc;
disp('  ');
disp('  SUBMODELO CONTROLABLE');
disp(' ');
P3=ss(A3,B3,C3,D3,Ts)
disp(' ');
disp(' autovalores del modelo')
disp(' ')
pole(P3)
disp(' ')

%% AUTOVALORES DE LAZO CERRADO
clc;
disp('  autovalores deseados para el sistema');
disp('  amortiguamiento critico psi= 1 ');
disp('  constante de tiempo     tau =1/(psi wn)= 0.2 seg.');
disp('  frecuencia natural      wn= 5');
disp(' ');
disp('  autovalores deseados');
p1=-5
p2=-5
disp(' ');
disp('  autovalores discretos');
z1=exp(p1*Ts)
z2=exp(p2*Ts)
disp(' ');
P=[z1 z2];
G2=zpk([],P,[1],Ts);
[num,den,Ts] = tfdata(G2,'v');
disp('  Coeficientes Ec. Caracteristica');
den
%% MODELO CANNICO CONTROLABLE
clc;
[P4,T]=canon(P3,'companion');
P4=P4.';
disp('   MODELO CANONICO CONTROLABLE');
disp(' ');
P4
G4=tf(P4);
[num4,den4,Ts] = tfdata(G4,'v');
den4;
dif=den-den4;
% vector del MCC
disp(' ');
disp('   VECTOR DE REALIMENTACIN DEL MCC');

Kt1=[dif(3) dif(2)]

u3=ctrb(P3);
u4=ctrb(P4);
%Matriz de transformacin al MCC
disp(' ');
disp('   MATRIZ DE TRANSFORMACIN AL MCC');

P=u3*u4^-1

disp(' ');
disp('   VECTOR DEL SUB-MODELO CONTROLABLE');

Kt2=Kt1*P^-1

disp(' ');
disp('   VECTOR AMPLIADO A TRES VARIABLES');

Kt3=[Kt2,0]

disp(' ');
disp('   VECTOR DE REALIMENTACIN');

Kt4=Kt3*Q^-1

%%
clc;
A=P1.a-P1.b*Kt4;
P5=P1;
P5.a=A;
disp('  Modelo realimentado');
P5
disp('  Autovalores realimentados.')
pole(P5)

